<?php

/* 
 * irmp3.php - the function to send a command to irmp3 using mod_netctl
 *
 * Copyright (c) by Andreas S. Krebs (andreas.krebs@web.de)
 *
 */

function irmp3_cmd($host, $port, $command, $answer)
{
  $fp=fsockopen($host, $port);
  if(!$fp)
  {
    echo("<HTML><BODY>ERROR accessing IRMP3 at $host:$port</BODY></HTML>");
    return false;
  }

  if(is_array($command)==false)
    $a_cmd=array($command);
  else
    $a_cmd=$command;

  // send the commands to irmp3
  foreach($a_cmd as $cmd)
  {
    fputs($fp, "$cmd\n");
  }

  if(is_array($answer)==false)
    $a_ans=array($answer);
  else
  {
    $a_ans=$answer;
  }

  socket_set_blocking($fp, false);

  $ret=array();
  foreach($a_ans as $ans)
  {
    // read some lines, until we get the answer we want
    $cnt=0;
    do
    {
      $tout=0;
      do
      {
        $tmp=fgets($fp, 4096);
        $tout++;
       
        if(strlen($tmp)==0)
          usleep(100000);
      }while(strlen($tmp)==0 && $tout<10);

      if($tout>=10)
        break 2;

      $entry=split(" ", $tmp, 3);
      $entry[1]=trim($entry[1]);

      if($entry[0] != "230:")		// we only care about 230 messages
        $entry[1]="";
      else
      {
        if($entry[1]=="info")
        {
          $inf=split(" ", $entry[2], 2);
          $entry[1]="info_".trim($inf[0]);
          $entry[2]=trim($inf[1]);
        }

        $ret[$entry[1]]=trim($entry[2]);
      }

      $cnt++;
    }while($entry[1]!=$ans && $cnt<20);
  }

  fclose($fp);

  // now add the command to the return array
  foreach($a_cmd as $cmd)
  {
    $entry=split(" ", $cmd, 2);
    $ret[$entry[0]]=trim($entry[1]);
  }

  return $ret;
}

?>
