#!/bin/sh
#
# create_muwed.sh - a very simple shell script to create the muwed postgresql database
#
# Copyright (c) by Andreas S. Krebs (andreas.krebs@web.de)
#

DBNAME=muwed
DBUSER=postgres

# create the database
createdb -U $DBUSER $DBNAME

# create the songs table
psql $DBNAME $DBUSER -c "CREATE TABLE songs (file TEXT NOT NULL UNIQUE, title TEXT, artist TEXT, album TEXT, note TEXT, year INT, genre INT, filesize INT, length INT, bitrate INT, flags INT, id SERIAL PRIMARY KEY, composer TEXT, track INT);"

# create the playlists table
psql $DBNAME $DBUSER -c "CREATE TABLE playlists (file TEXT NOT NULL UNIQUE, title TEXT, note TEXT, id SERIAL PRIMARY KEY);"

# create the playlist entries table
psql $DBNAME $DBUSER -c "CREATE TABLE pl_entries (pl_id INT4 REFERENCES playlists (id) ON DELETE CASCADE, s_id INT4 REFERENCES songs (id) ON DELETE CASCADE, PRIMARY KEY (pl_id, s_id));"

